﻿' Script : max_monitor script
' Purpose: communication with Max! Gateway
' Author : BLB
' Version: 02 initial release


' import required modules
Imports System.Net
Imports System.Net.Sockets
Imports System.Text

Const INI_FILE As String = "hspi_Max_monitor.ini"        ' name ini file
Const swversion = "0.2"                                  ' the version of this file

Sub Main(ByVal varParameters)
    'define variables
    Dim Debug       As Boolean = False                                           ' True
    Dim Info        As Boolean = True                                            ' False
    Dim MaxCommand  As String  = varParameters
    Dim Client      As New TcpClient()
    Dim strHC       As String  = hs.GetINISetting("Startup", "HouseCode", "", INI_FILE)                                                    ' house code
    Dim DevLocation As String  = hs.GetINISetting("Startup", "DevLocation", "", INI_FILE)
    Dim RemoteIP    As String  = hs.GetINISetting("Startup", "TCPAddress", "", INI_FILE)
    Dim PortNumber  As Integer = hs.GetINISetting("Startup", "TCPPort", "", INI_FILE)
    Dim Temp        As String
    Dim Message     As String
    Dim ResponseH, ResponseM, ResponseC(100),ResponseL  As String
    Dim ResponseH_SN, ResponseH_Ad,ResponseH_Fw, ResponseH_P4, ResponseH_P5, ResponseH_P6 As String
    Dim ResponseM_P1, ResponseM_P2, ResponseM_P3
    Dim PositionH, PositionM, PositionC(100), PositionL As String
    Dim Seperator(100) as Integer
    Dim Counter As Integer = 0
    Dim Tcnt As Integer = 20
    Dim M_Rnumber(Tcnt), M_Rname(Tcnt), M_Raddress(Tcnt) , M_D_Type(Tcnt), M_Daddress(Tcnt), M_D_SN(Tcnt) As String
    Dim M_D_room(Tcnt) , M_DName(Tcnt), M_DRoom(Tcnt) As String
    Dim Caddress(Tcnt), C_type(Tcnt), C_SN(Tcnt), C_Week(Tcnt) As String
    Dim C_Com_Temp(Tcnt), C_Eco_Temp(Tcnt), C_Max_Temp(Tcnt), C_Min_Temp(Tcnt), C_Off_Temp(Tcnt), C_Win_Temp(Tcnt) As single
    Dim C_Win_Dura(Tcnt), C_Dur_Boos(Tcnt), C_Val_Boos(Tcnt), C_Dti_deca(Tcnt), C_max_Valv(Tcnt), C_off_Valv(Tcnt) As String
    Dim C_Wk(7) As String
    Dim Taddress(Tcnt), Tvalid(Tcnt), Terror(Tcnt), Tanswer(Tcnt), Tstatus(Tcnt) As String
    Dim Tbattery(Tcnt), Tlinkstatus(Tcnt), Tpanel(Tcnt), Tgateway(Tcnt), Tdts(Tcnt), Tmode1(Tcnt), Tmode2(Tcnt) As String
    Dim TTemp(Tcnt) As Single
    Dim Tdate(Tcnt), Ttime(Tcnt), TdateTime(Tcnt) As String 
    
    If debug Or info Then hs.WriteLog("Max", "SWversion: " & swversion)
 
    'Device Type Names for Cube (n1) and Thermostats (n2) 
    Dim n1(3), n2(8)
    n1(1) = "Address/SerialNr/Firmw"
    n2(1)= "Address/SerialNr"
    n2(2)= "Temperatures1"
    n2(3)= "Temperatures2"
    n2(4)= "Program Today"
    n2(5)= "Mode/Setpoint/EndDateTime"
   
    Try
        ' Connect to the remote
        Client.Connect(IPAddress.Parse(RemoteIP), PortNumber)
        Dim NetStream As NetworkStream = Client.GetStream()
        ' Receive reply. After initial Connect, the Cube gives always an initial response with all?? info
        hs.WaitSecs(2)
        Dim Reply As String = ReadString(Client)
        If Debug Then hs.WriteLog("debug", Reply)              ' full reply to logfile
    
        ' Search seperators (:) in initial response string and put all fields in seperate variables Seperator()
        Seperator(Counter) = 1
        Do Until Seperator(Counter) = 0
            Seperator(Counter+1) = InStr(Seperator(Counter)+1,Reply,":")
            Counter += 1                                       ' counter hold number of fields in the reply
        Loop
        
        ' Search the different responses from the initial response string and split them in all known parameters
        Dim i As Integer                                     ' i = counter to the number of fields in reply
        Dim dev As Integer = 1
        For i = 1 To counter-1
            If i = counter-1 Then Seperator(i+1) = Reply.length
            Select Case Mid(Reply,Seperator(i)-1,2)
                Case "H:"                                      ' The H response contains information about the Cube.
                    ResponseH = Mid(Reply,Seperator(i)+1,Seperator(i+1)-Seperator(i)-2)
                    If debug Then hs.WriteLog("debugH", ResponseH)
                    ResponseH_SN = hs.StringItem(ResponseH,1,",")
                    ResponseH_Ad = Hex2Dec(hs.StringItem(ResponseH,2,","))
                    ResponseH_Fw = hs.StringItem(ResponseH,3,",")
                    ResponseH_P4 = hs.StringItem(ResponseH,4,",")
                    ResponseH_P5 = hs.StringItem(ResponseH,5,",")
                    ResponseH_P6 = hs.StringItem(ResponseH,6,",")
                    If info Then hs.WriteLog("infoH", "Cube Serial number: " & ResponseH_SN & " Cube Address: " & ResponseH_Ad & " Cube Firmware: " & ResponseH_Fw)
                Case "M:"                                      ' The M response contains Metadata; rooms, device names etc
                    ResponseM = Mid(Reply,Seperator(i)+1,Seperator(i+1)-Seperator(i)-2)
                    If debug Then hs.WriteLog("debugM", ResponseM)
                    ResponseM_P1 = hs.StringItem(ResponseM,1,",")
                    ResponseM_P2 = hs.StringItem(ResponseM,2,",")
                    ResponseM_P3 = Base64ToHex(hs.StringItem(ResponseM,3,","))
                    If debug Then hs.WriteLog("infoM", ResponseM_P1 & " " & ResponseM_P2 & " " & ResponseM_P3)
                    Dim Name_Length, M_pointer, M_R_count, M_D_count, M_Rooms, M_Devices, Mi As Integer
                    M_pointer     = 5
                    M_R_count     = 1
                    M_Rooms       = Val("&H" & Mid(ResponseM_P3,M_pointer,2))
                    M_pointer    += 2
                    
                    For Mi = 1 To M_Rooms
                        M_Rnumber(Mi)  = Val("&H" & Mid(ResponseM_P3,M_pointer,2))
                        M_pointer     += 2
                        Name_Length    = Val("&H" & Mid(ResponseM_P3,M_pointer,2)) * 2
                        M_pointer     += 2
                        M_RName(Mi)    = Hex2asc(Mid(ResponseM_P3,M_pointer,Name_Length))
                        M_pointer     += Name_Length
                        M_Raddress(Mi) = Hex2Dec(Mid(ResponseM_P3,M_pointer,6))
                        M_pointer     += 6
                        If info Then hs.WriteLog("infoM", "#rooms: " & CStr(M_rooms) & " RoomNumber: " & CStr(M_Rnumber(Mi)) & " RoomName: " & _
                                        M_RName(Mi) & " 1stAddressInRoom: " & M_Raddress(Mi))
                    Next
                    M_R_count     = 1
                    M_Devices     = Val("&H" & Mid(ResponseM_P3,M_pointer,2))
                    M_pointer    += 2
                    
                    For Mi = 1 To M_Devices
                        M_D_type(Mi)    = Mid(ResponseM_P3,M_pointer,2)
                        M_pointer      += 2
                        M_Daddress(Mi)  = Hex2Dec(Mid(ResponseM_P3,M_pointer,6))
                        M_pointer      += 6
                        M_D_SN(Mi)      = Hex2asc(Mid(ResponseM_P3,M_pointer,20))
                        M_pointer      += 20
                        Name_Length     = Val("&H" & Mid(ResponseM_P3,M_pointer,2)) * 2
                        M_pointer      += 2
                        M_DName(Mi)     = Hex2asc(Mid(ResponseM_P3,M_pointer,Name_Length))
                        M_pointer      += Name_Length
                        M_DRoom(Mi)     = Val("&H" & Mid(ResponseM_P3,M_pointer,2))
                        M_pointer      += 2
                        If info Then hs.WriteLog("infoM", "#Devices: " & CStr(M_Devices) & " DeviceType: " & M_D_type(Mi) & _
                                        " DeviceAddress: " & M_Daddress(Mi) & " SN: " & M_D_SN(Mi) & " DeviceName: " & M_DName(Mi) & _
                                        " DeviceRoom: " & M_DRoom(Mi))
                    Next
                Case "L:"
                    ResponseL = Base64ToHex(Mid(Reply,Seperator(i)+1,Seperator(i+1)-Seperator(i)-2))
                    Tcnt = ResponseL.length / 24
                    Dim t As Integer 
                    Dim L(Tcnt) As String
    
                    For t = 1 To Tcnt
                        L(t)           = Mid(ResponseL,(t-1)*24+1,24)
                        If debug Then hs.WriteLog("debugL", "Device " & CStr(t) & ": " & L(t))
                        Taddress(t)    = Hex2Dec(Mid(L(t),3,6))
                        Temp           = Hex2Bin(Mid(L(t),11,2))                'convert byte 6 to binary status bits
                        Tvalid(t)      = Mid(Temp,4,1)
                        Terror(t)      = Mid(Temp,5,1)
                        Tanswer(t)     = Mid(Temp,6,1)
                        Tstatus(t)     = Mid(Temp,7,1)
                        Temp           = Hex2Bin(Mid(L(t),13,2))                'convert byte 7 to binary status bits
                        Tbattery(t)    = Mid(Temp,1,1)
                        Tlinkstatus(t) = Mid(Temp,2,1)
                        Tpanel(t)      = Mid(Temp,3,1)
                        Tgateway(t)    = Mid(Temp,4,1)
                        Tdts(t)        = Mid(Temp,5,1)
                        Tmode1(t)       = Mid(Temp,7,2)
                        Select Case Tmode1(t)
                            Case "00"
                                'auto/week schedule
                                Tmode2(t) = "Auto"
                            Case "01"
                                'Manual
                                Tmode2(t) = "Manual"
                            Case "10"
                                'Party/Vacation
                                Tmode2(t) = "Party/Vacation"
                            Case "11"
                                'Boost
                                Tmode2(t) = "Boost"
                            Case Else
                                'something wrong'
                        End Select
                        Ttemp(t) = Val("&h" & Mid(L(t),17,2)) / 2
                        Dim datehex As Double = Val("&h" & Mid(L(t),19,4))
                        If datehex = 0 Or Tmode1(t) = "00" Then
                            Tdate(t) = DateSerial(0000,0,0)
                            Ttime(t) = TimeSerial(0,0,0)
                            TdateTime(t) = "--"
                        Else
                            Tdate(t) = DateSerial(2000 + (datehex And &h0F),((datehex And  &hE000) >> 12)+((datehex And &h80) >> 7),(datehex And &h1F00) >> 8)
                            Ttime(t) = TimeSerial(Int(Val("&h" & Mid(L(t),23,2))/2),(Val("&h" & Mid(L(t),23,2))/2 - int(Val("&h" & Mid(L(t),23,2))/2))*60,0)
                            TdateTime(t) = FormatDateTime(Tdate(t) & " " & Ttime(t))
                        End If
                        If info Then hs.WriteLog("infoL","address: " & Taddress(t) & " tvalid: " & Tvalid(t) & " Terror: " & Terror(t)& " Tanswer:  " & Tanswer(t) & " mode: " & Tmode2(t) & " Temp: " & CStr(Ttemp(t)) & " date: " & TdateTime(t))
                    Next
                    'hs.WriteLog("debug", ResponseL)
               Case "C:"
                    ResponseC(dev) = Mid(Reply,Seperator(i)+1,Seperator(i+1)-Seperator(i)-2)
                    Dim j1, j2, j3 As Integer
                    Dim WP, WP2, WP3, WP4 As String
    
                    Caddress(dev)   = Hex2Dec(hs.StringItem(ResponseC(dev),1,","))
                    Temp            = Base64ToHex(hs.StringItem(ResponseC(dev),2,","))
                    
                    C_type(dev)     = Mid(Temp,9,2)
                    C_SN(dev)       = hex2asc(Mid(Temp,17,20))
                    If info Then hs.WriteLog("infoC" & CStr(dev), "address: " & Caddress(dev) & " type: " & C_type(dev) & " SerialNR: " & C_SN(dev))
                    Select Case C_Type(dev)
                        Case "00"
                            ' cube
                        Case "01"                   
                            C_Com_Temp(dev) = Val("&h" & Mid(Temp,37,2)) / 2               ' comfort temperature
                            C_Eco_Temp(dev) = Val("&h" & Mid(Temp,39,2)) / 2               ' Eco Temperature
                            C_Max_Temp(dev) = Val("&h" & Mid(Temp,41,2)) / 2               ' Max Temperature
                            C_Min_Temp(dev) = Val("&h" & Mid(Temp,43,2)) / 2               ' Min Temperature
                            C_Off_Temp(dev) = Val("&h" & Mid(Temp,45,2)) / 2 - 3.5         ' offset possible is -3,5 to 3,5 degrees, 3,5 = 0
                            C_Win_Temp(dev) = Val("&h" & Mid(Temp,47,2)) / 2               ' window open temperature
                            C_Win_Dura(dev) = Mid(Temp,49,2)                               ' window open duration
                            C_Dur_Boos(dev) = Bin2Dec(Left(Hex2Bin(Mid(Temp,51,2)),3))     ' Boost duration
                            If C_Dur_Boos(dev) = "7" Then C_Dur_Boos(dev) = "30"
                            C_Val_Boos(dev) = Bin2Dec(Mid(Hex2Bin(Mid(Temp,51,2)),4,5))*5 & "%"    ' Boost Valve Value (%)
                            C_Dti_deca(dev) = WeekdayName(Bin2Dec(Left(Hex2Bin(Mid(Temp,53,2)),3))+1,True,7) & " " & _
                                              Bin2Dec(Mid(Hex2Bin(Mid(Temp,53,2)),4,5)) & ":00u"   ' Decalcification: Day of week and Time
                            C_max_Valv(dev) = Val("&h" & Mid(Temp,55,2))*100/255           ' Maximum Valve setting; *(100/255) to get in %
                            C_off_Valv(dev) = Val("&h" & Mid(Temp,57,2))*100/255           ' Valve Offset ; *(100/255) to get in %
    
                            For j1 = 1 To 7                                                ' days of the week
                                WP = Mid(Temp, 7 + 52 * j1, 52)                            ' string with (13) values for the selected day
                                C_Wk(j1) = "Temp/Time: "
                                j2 = 1
                                Do
                                    WP2 = Bin2Dec(Mid(Hex2Bin(Mid(WP,1+(j2-1)*4,4)),2,6))/2    ' temperature
                                    WP3 = Bin2Dec(Mid(Hex2Bin(Mid(WP,1+(j2-1)*4,4)),8,9))*5    ' time in minutes
                                    WP4 = FormatDateTime(TimeSerial(0,Wp3,0),4)                ' formatted time (in hours)
                                    C_Wk(j1) = C_Wk(j1) & "("&j2 & ") " & WP2 & "/" & WP4 & " "  
                                    j2 += 1
                                Loop until wp3 = "1440" Or j2 = 13
                                If j1 = Weekday(Now(),7) Then C_Week(dev) = C_Wk(j1)           ' copy current day to C_Week() variable
                                If info Then hs.WriteLog("infoC" & CStr(dev),WeekdayName(J1,True,7) & " " & Weekday(Now(),7) & " " & C_Wk(j1))
                            Next
                            If info Then hs.WriteLog("infoC" & CStr(dev),"ComT: " & C_Com_Temp(dev) & " EcoT: " & C_Eco_Temp(dev) & " MaxT: " & C_Max_Temp(dev) & " MinT: " & C_Min_Temp(dev) & " OffT: " & C_Off_Temp(dev) & " WinT: " & C_Win_Temp(dev) & " WinDur: " & C_Win_Dura(dev) & " Boostdur: " & C_Dur_Boos(dev) & " BoostVal: " & C_Val_Boos(dev) & " datetime_decal: " & C_Dti_deca(dev)&"Valve_Max: "&C_max_Valv(dev)& "Valve_off: "& C_off_Valv(dev))
                        Case Else
                            ' unknown device
                            hs.WriteLog("debugC" & CStr(dev), " unknown device: " & C_Type(dev))
                    End Select
                    
                    If debug Then hs.WriteLog("debugC" & CStr(dev), "response: " & Temp)
                    dev +=1
                Case else
                    hs.WriteLog("MaxMonitor Error", " unknown command: " &  CStr(dev) & Mid(Reply,Seperator(i)-1,2))
            End Select
        Next

        ' all initial fields are read and processed
        ' update all Max Devices. If MaxDevices don't exist, they will be created
        Dim dv, C1, C2
        Dim DevName00, DevLocation2 As String
        
        Select Case MaxCommand
            Case ""                                   'no specific command, update all existing or create new
                Dim strDC As String = hs.GetINISetting("Cube", "FirstDeviceCode", "", INI_FILE)
                Dim strDV As String = strHC & strDC
                If hs.DeviceExistsRef(strDV) = -1 Then                                ' check if Cube exist. if not, create devices
                    DevName00    = hs.GetINISetting("Startup", "CubeName", "", INI_FILE)
                    DevLocation2 = hs.GetINISetting("Cube", "DevLocation2", "", INI_FILE)
                    For C1 = 1 To 1
                        dv                 = hs.GetDeviceByRef(hs.NewDeviceRef(DevName00))
                        dv.dc              = CStr(C1+ Int(strDC)-1)
                        dv.hc              = strHC
                        dv.can_dim         = False
                        dv.location        = DevLocation
                        dv.location2       = DevLocation2
                        dv.dev_type_string = n1(C1)
                        dv.misc            = &h10
                    Next
                End If
                ' update Cube Device
                hs.SetDeviceValue(strDV,ResponseH_Ad)                
                hs.SetDeviceString(strDV,CStr(ResponseH_Ad)& "/" & CStr(ResponseH_SN) & "/" & CStr(ResponseH_FW))
                
                'thermostats
                For C2 = 1 To Tcnt                                                   'Tcnt holds the number of Thermostats
                    strDC = hs.GetINISetting("Thermostat" & CStr(C2), "FirstDeviceCode", "", INI_FILE)
                    If strDC = "" Then hs.WriteLog("MaxMonitor Error","Thermostat setting in INI file incorrect")
                    strDV = strHC & strDC
                    If hs.DeviceExistsRef(strDV) = -1 Then        ' check if Thermostat exist. if not, create devices
                        DevName00    = hs.GetINISetting("Startup", "ThermostatName", "", INI_FILE)
                        DevLocation2 = M_RName(M_DRoom(C2))
                        For C1 = 1 To 5
                            dv                 = hs.GetDeviceByRef(hs.NewDeviceRef(DevName00))
                            dv.dc              = CStr(C1+ Int(strDC)-1)
                            dv.hc              = strHC
                            dv.can_dim         = False
                            dv.location        = DevLocation
                            dv.location2       = DevLocation2
                            dv.dev_type_string = n2(C1)
                            dv.misc            = &h10                       
                        Next
                    End If
                    'update Thermostats
                    hs.SetDeviceValue(strDV,M_Daddress(C2))                              ' address & SN
                    hs.SetDeviceString(strDV,CStr(M_Daddress(C2)) & "/" & CStr(M_D_SN(C2)))
                    ' lookup C response
                    C1 = 1
                    Do until Caddress(c1) = M_Daddress(C2) Or C1 = 100
                        C1+=1
                    Loop
                    Dim Temps As String = "Com: " & CStr(C_Com_Temp(C1)) & " Eco: " & C_Eco_Temp(C1) & " Win: " & C_Win_Temp(C1) 
                    hs.SetDeviceValue(strHC & CStr(Int(strDC)+1),C_Com_Temp(C1) * 10000000 + C_Eco_Temp(C1) * 10000 + C_Win_Temp(C1)*10)  ' Temperature1                
                    hs.SetDeviceString(strHC & CStr(Int(strDC)+1),Temps)
                    
                    Temps = "Max: " & CStr(C_Max_Temp(C1)) & " Min: " & C_Min_Temp(C1) & " Offset: " & C_Off_Temp(C1) 
                    hs.SetDeviceValue(strHC & CStr(Int(strDC)+2),C_Max_Temp(C1) * 10000000 + C_Min_Temp(C1) * 10000 + C_Off_Temp(C1)*10)  ' Temperature2                
                    hs.SetDeviceString(strHC & CStr(Int(strDC)+2),Temps)
                    hs.SetDeviceValue(strHC & CStr(Int(strDC)+3),Weekday(Now(),7))       'Auto Day schedule
                    hs.SetDeviceString(strHC & CStr(Int(strDC)+3),C_Week(C1))
                    ' lookup L response
                    C1 = 1
                    Do until Taddress(c1) = M_Daddress(C2) Or C1 = 100
                        C1+=1
                    Loop
                    hs.SetDeviceValue(strHC & CStr(Int(strDC)+4),Tmode1(C1)*1000 + Ttemp(C1)*10)     'Mode/Setpoint/EndDateTime
                    hs.SetDeviceString(strHC & CStr(Int(strDC)+4),Tmode2(C1)&"/"&CStr(Ttemp(C1))&"/"&TdateTime(C1))

                Next                    

            Case "l:"
                SendString(NetStream, MaxCommand & vbCrLf)
                ' Receive reply
                hs.WaitSecs(1)
                Reply = ReadString(Client)
                hs.WriteLog("debug", Reply)  
            Case Else
                hs.WriteLog("MaxMonitor Error", " unknown command: " &  MaxCommand)            
        End Select
        
        ' Disconnect at the end
        Client.Close()

    Catch ex As Exception
        hs.WriteLog("MaxMonitor Error","Communication Error: " & ex.Message)
    End Try
    
End Sub 

Private Function ReadString(ByVal Client As System.Net.Sockets.TcpClient) As String
    Dim Stream As NetworkStream = Client.GetStream
    Dim Buffersize As Integer = Client.ReceiveBufferSize
    Dim Data(Buffersize -1) As Byte
    If Stream.CanTimeout Then
        Stream.ReadTimeout = 1000 * 15
    End If
    Dim BytesRead As Integer = Stream.Read(Data, 0, Buffersize)
    Return Encoding.ASCII.GetString(Data, 0, BytesRead)
End Function
 
Private Function SendString(ByVal Stream As NetworkStream, ByVal Data As String) As Boolean
    Dim Bytes As [Byte]() = Encoding.ASCII.GetBytes(Data)
    If Stream.CanTimeout Then
        Stream.WriteTimeout = 1000 * 5
    End If
    Stream.Write(Bytes, 0, Bytes.Length)
    Return True
End Function

Private Function Base64ToHex(base64string As String) As String
    Dim result As String
    Dim b64bytes() As Byte = System.Convert.FromBase64String(base64string)
    For Each b As Byte In b64bytes
        result &= Hex(b).PadLeft(2, "0"c)
    Next
    Return result
End Function

Private Function HexToBase64(ByVal HexText As String) As String
    Dim HexTextBytes As Integer = HexText.Length \ 2 -1
    Dim result(HexTextBytes) As Byte
    Dim i As Integer
    For i = 0 To HexTextBytes
        result(i) = Convert.ToByte(HexText.Substring(i * 2, 2), 16)
    Next
    Return Convert.ToBase64String(result)
End Function

Private Function Hex2Bin(ByVal dwHex As String) As String
    dwHex = CStr(dwHex)
    Dim sTemp As String
    Dim I As Integer
    For I = 1 To Len(dwHex)
        sTemp = Mid(dwHex, I, 1)
        Select Case sTemp
            Case "0": Hex2Bin = Hex2Bin & "0000"
            Case "1": Hex2Bin = Hex2Bin & "0001"
            Case "2": Hex2Bin = Hex2Bin & "0010"
            Case "3": Hex2Bin = Hex2Bin & "0011"
            Case "4": Hex2Bin = Hex2Bin & "0100"
            Case "5": Hex2Bin = Hex2Bin & "0101"
            Case "6": Hex2Bin = Hex2Bin & "0110"
            Case "7": Hex2Bin = Hex2Bin & "0111"
            Case "8": Hex2Bin = Hex2Bin & "1000"
            Case "9": Hex2Bin = Hex2Bin & "1001"
            Case "A": Hex2Bin = Hex2Bin & "1010"
            Case "B": Hex2Bin = Hex2Bin & "1011"
            Case "C": Hex2Bin = Hex2Bin & "1100"
            Case "D": Hex2Bin = Hex2Bin & "1101"
            Case "E": Hex2Bin = Hex2Bin & "1110"
            Case "F": Hex2Bin = Hex2Bin & "1111"
        End Select
    Next I
End Function 

Private Function Hex2Dec(Hextext As String) As String
    Dim result As String = Convert.ToInt32(Hextext,16)
    Return result
End Function


Private Function Hex2asc(Hextext As String) As String
    Dim result As String
    Dim i As Integer
    For i = 0 To HexText.Length \ 2 -1
        result &= Chr(Val("&h" & Mid(HexText,i*2+1,2)))
    Next
    Return result
End Function

Private Function Bin2Dec(Binary As String) As long
    Dim result As Long
    Dim s As Integer
    For s = 1 To Len(Binary)
        result += (Mid(Binary, Len(Binary) - s + 1, 1) * (2 ^ (s - 1)))
    Next s
    Return result
End Function

' new, not tested yet 20110912
'Private Function Dec2Bin(DecimalNum As Long) As String
'    Dim tmp As String
'    Dim n As Long
'    n = DecimalNum
'    tmp = Trim(Str(n Mod 2))
'    n = n \ 2
'    Do While n <> 0
'        tmp = Trim(Str(n Mod 2)) & tmp
'        n = n \ 2
'    Loop
'    Return tmp
'End Function